| The Gaudi Framework v32r1 (f65d50dc)

Classes | Namespaces | Macros | Enumerations | Functions
ProcessDescriptor.cpp File Reference
`#include "libgen.h"`
`#include "sys/times.h"`
`#include "unistd.h"`
`#include <cstdio>`
`#include <errno.h>`
`#include <fcntl.h>`
`#include <iostream>`
`#include <sstream>`
`#include <string>`
`#include <sys/signal.h>`
`#include <sys/syscall.h>`
`#include <sys/types.h>`
`#include <sys/procfs.h>`
`#include <sys/resource.h>`
`#include <sys/time.h>`
`#include "GaudiKernel/ModuleInfo.h"`
`#include "GaudiKernel/System.h"`
`#include "ProcessDescriptor.h"`
Include dependency graph for ProcessDescriptor.cpp:

Go to the source code of this file.

## Classes
struct | linux_proc

## Namespaces
| System
| Note: OS specific details for environment resolution.

## Macros
#define | GAUDIKERNEL_PROCSTAT_CPP
#define | WINVER 0

## Enumerations
enum | System::ProcessInfoCommand { System::ProcessBasicInformation, System::ProcessQuotaLimits, System::ProcessIoCounters, System::ProcessVmCounters, System::ProcessTimes, System::ProcessBasePriority, System::ProcessRaisePriority, System::ProcessDebugPort, System::ProcessExceptionPort, System::ProcessAccessToken, System::ProcessLdtInformation, System::ProcessLdtSize, System::ProcessDefaultHardErrorMode, System::ProcessIoPortHandlers, System::ProcessPooledUsageAndLimits, System::ProcessWorkingSetWatch, System::ProcessUserModeIOPL, System::ProcessEnableAlignmentFaultFixup, System::ProcessPriorityClass, System::ProcessWx86Information, System::ProcessHandleCount, System::ProcessAffinityMask, System::ProcessPriorityBoost, System::MaxProcessInfoClass, System::ProcessEllapsedTime }

## Functions
void | readProcStat (long pid, linux_proc &pinfo)

## Macro Definition Documentation

## ◆ GAUDIKERNEL_PROCSTAT_CPP

#define GAUDIKERNEL_PROCSTAT_CPP

Definition at line 15 of file ProcessDescriptor.cpp.

## ◆ WINVER

#define WINVER 0

Definition at line 70 of file ProcessDescriptor.cpp.

## Function Documentation

## ◆ readProcStat()

void readProcStat | ( | long | pid,
|  | linux_proc & | pinfo
| ) |  |

Definition at line 301 of file ProcessDescriptor.cpp.

301 {
302
303 int cnt, fd;
304 char buf[512];
305
306 std::ostringstream ost;
307
308 ost << "/proc/" << pid << "/stat";
309 std::string fname = ost.str();
310 if ( ( fd = open( fname.c_str(), O_RDONLY ) ) < 0 ) {
311 std::cerr << "Failed to open " << ost.str() << std::endl;
312 return;
313 }
314
315 lseek( fd, 0, SEEK_SET );
316 if ( ( cnt = read( fd, buf, sizeof( buf ) - 1 ) ) < 0 ) {
317 std::cout << "LINUX Read of Proc file failed:" << std::endl;
318 close( fd );
319 return;
320 }
321
322 // Format
323 if ( cnt > 0 ) {
324 buf[cnt] = '\0';
325 sscanf( buf,
326 // 1 2 3 4 5 6 7 8 9 10 1 2 3 4 5 6 7 8 9 20 1 2 3 4 5 6 7 8 9
327 // 30 1 2 3 4 5
328 "%d %s %c %d %d %d %d %d %lu %lu %lu %lu %lu %lu %lu %ld %ld %ld %ld %ld %ld %llu %lu %ld %lu %lu %lu %lu "
329 "%lu %lu %lu %lu %lu %lu %lu",
330 &pinfo.pid, pinfo.comm, &pinfo.state, &pinfo.ppid, &pinfo.pgrp, &pinfo.session, &pinfo.tty, &pinfo.tpgid,
331 &pinfo.flags, &pinfo.minflt, &pinfo.cminflt, &pinfo.majflt, &pinfo.cmajflt, &pinfo.utime, &pinfo.stime,
332 &pinfo.cutime, &pinfo.cstime, &pinfo.priority, &pinfo.nice, &pinfo.num_threads, &pinfo.itrealvalue,
333 &pinfo.starttime, &pinfo.vsize, &pinfo.rss, &pinfo.rlim, &pinfo.startcode, &pinfo.endcode,
334 &pinfo.startstack, &pinfo.kstkesp, &pinfo.kstkeip, &pinfo.signal, &pinfo.blocked, &pinfo.sigignore,
335 &pinfo.sigcatch, &pinfo.wchan );
336 }
337 close( fd );
338 }
linux_proc::minflt
unsigned long minflt
Definition: ProcessDescriptor.cpp:268
linux_proc::kstkesp
unsigned long kstkesp
Definition: ProcessDescriptor.cpp:287
linux_proc::signal
unsigned long signal
Definition: ProcessDescriptor.cpp:289
linux_proc::wchan
unsigned long wchan
Definition: ProcessDescriptor.cpp:293
gaudirun.fd
fd
Definition: gaudirun.py:559
linux_proc::sigcatch
unsigned long sigcatch
Definition: ProcessDescriptor.cpp:292
linux_proc::state
char state
Definition: ProcessDescriptor.cpp:261
linux_proc::tty
int tty
Definition: ProcessDescriptor.cpp:265
std::sscanf
T sscanf(T... args)
linux_proc::flags
unsigned long flags
Definition: ProcessDescriptor.cpp:267
linux_proc::pid
int pid
Definition: ProcessDescriptor.cpp:259
std::endl
T endl(T... args)
linux_proc::comm
char comm[400]
Definition: ProcessDescriptor.cpp:260
linux_proc::num_threads
long num_threads
Definition: ProcessDescriptor.cpp:278
hivetimeline.read
def read(f, regex='.*', skipevents=0)
Definition: hivetimeline.py:22
linux_proc::session
int session
Definition: ProcessDescriptor.cpp:264
std::string
STL class.
linux_proc::cstime
long cstime
Definition: ProcessDescriptor.cpp:275
linux_proc::pgrp
int pgrp
Definition: ProcessDescriptor.cpp:263
linux_proc::cutime
long cutime
Definition: ProcessDescriptor.cpp:274
linux_proc::nice
long nice
Definition: ProcessDescriptor.cpp:277
std::ostringstream
STL class.
linux_proc::itrealvalue
long itrealvalue
Definition: ProcessDescriptor.cpp:279
linux_proc::vsize
unsigned long vsize
Definition: ProcessDescriptor.cpp:281
std::ostringstream::str
T str(T... args)
linux_proc::startstack
unsigned long startstack
Definition: ProcessDescriptor.cpp:286
linux_proc::rss
long rss
Definition: ProcessDescriptor.cpp:282
linux_proc::cminflt
unsigned long cminflt
Definition: ProcessDescriptor.cpp:269
linux_proc::tpgid
int tpgid
Definition: ProcessDescriptor.cpp:266
linux_proc::majflt
unsigned long majflt
Definition: ProcessDescriptor.cpp:270
linux_proc::starttime
unsigned long long starttime
Definition: ProcessDescriptor.cpp:280
linux_proc::cmajflt
unsigned long cmajflt
Definition: ProcessDescriptor.cpp:271
linux_proc::kstkeip
unsigned long kstkeip
Definition: ProcessDescriptor.cpp:288
linux_proc::priority
long priority
Definition: ProcessDescriptor.cpp:276
linux_proc::startcode
unsigned long startcode
Definition: ProcessDescriptor.cpp:284
std::string::c_str
T c_str(T... args)
linux_proc::utime
unsigned long utime
Definition: ProcessDescriptor.cpp:272
linux_proc::ppid
int ppid
Definition: ProcessDescriptor.cpp:262
linux_proc::blocked
unsigned long blocked
Definition: ProcessDescriptor.cpp:290
std::cerr
linux_proc::endcode
unsigned long endcode
Definition: ProcessDescriptor.cpp:285
linux_proc::stime
unsigned long stime
Definition: ProcessDescriptor.cpp:273
linux_proc::sigignore
unsigned long sigignore
Definition: ProcessDescriptor.cpp:291
linux_proc::rlim
unsigned long rlim
Definition: ProcessDescriptor.cpp:283